Re: [PATCH v2 2/2] revision: allow --ancestry-path to take an argument

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

 



On 8/18/2022 2:17 AM, Elijah Newren via GitGitGadget wrote:
> From: Elijah Newren <newren@xxxxxxxxx>

Code looks good!

> diff --git a/t/t6019-rev-list-ancestry-path.sh b/t/t6019-rev-list-ancestry-path.sh
> index af57a04b7ff..d3657737fa6 100755
> --- a/t/t6019-rev-list-ancestry-path.sh
> +++ b/t/t6019-rev-list-ancestry-path.sh
> @@ -8,8 +8,13 @@ test_description='--ancestry-path'
>  #   /                     \
>  #  A-------K---------------L--M
>  #
> -#  D..M                 == E F G H I J K L M
> -#  --ancestry-path D..M == E F H I J L M
> +#  D..M                                     == E F G H I J K L M
> +#  --ancestry-path                     D..M == E F   H I J   L M
> +#  --ancestry-path=F                   D..M == E F       J   L M
> +#  --ancestry-path=G                   D..M ==     G H I J   L M
> +#  --ancestry-path=H                   D..M == E   G H I J   L M
> +#  --ancestry-path=K                   D..M ==             K L M
> +#  --ancestry-path=K --ancestry-path=F D..M == E F       J K L M

These are good examples, because they help clarify what I had initially
been confused about: you include things in _both_ directions. In
particular, "--ancestry-path=K --ancestry-path=f D..M" you are kind of
taking the union of the following queries:

	--ancestry-path D..K
	--ancestry-path K..M
	--ancestry-path D..F
	--ancestry-path F..M

I did check just in case, but specifying multiple ranges such as

	--ancestry-path D..K K..M

does not do what is expected.

> +test_expect_success 'rev-list --ancestry-path=F D..M' '
> +	test_write_lines E F J L M >expect &&
> +	git rev-list --ancestry-path=F --format=%s D..M |
> +	sed -e "/^commit /d" |
> +	sort >actual &&
> +	test_cmp expect actual
> +'

These tests follow the patterns from other tests in this file, but
it also has bad patterns. Specifically, the 'git rev-list' command
is fed directly into a pipe. I include a patch below that applies
directly on this one to rewrite these tests. If you want, you could
rebase to have that test refactor happen before you add your new
--ancestry-path=<X> option tests.

> +test_expect_success 'rev-list --ancestry-path=G D..M' '
> +	test_write_lines G H I J L M >expect &&
> +	git rev-list --ancestry-path=G --format=%s D..M |
> +	sed -e "/^commit /d" |
> +	sort >actual &&
> +	test_cmp expect actual
> +'
> +test_expect_success 'rev-list --ancestry-path=H D..M' '

nit: needs extra whitespace between tests. The above test pair
needs one, too. This becomes moot with the patch I provide.

Thanks,
-Stolee

--- >8 ---

>From 9ac4e81dba0d7801513a09f5fe307d01357123dd Mon Sep 17 00:00:00 2001
From: Derrick Stolee <derrickstolee@xxxxxxxxxx>
Date: Thu, 18 Aug 2022 11:25:04 -0400
Subject: [PATCH] t6019: modernize tests with helper

The tests in t6019 are repetive, so create a helper that greatly
simplifies the test script.

In addition, update the common pattern that places 'git rev-list' on the
left side of a pipe, which can hide some exit codes. Send the output to
a 'raw' file that is then consumed by other tools so the Git exit code
is verified as zero.

Signed-off-by: Derrick Stolee <derrickstolee@xxxxxxxxxx>
---
 t/t6019-rev-list-ancestry-path.sh | 131 +++++++-----------------------
 1 file changed, 31 insertions(+), 100 deletions(-)

diff --git a/t/t6019-rev-list-ancestry-path.sh b/t/t6019-rev-list-ancestry-path.sh
index d3657737fa60..18941a80ce67 100755
--- a/t/t6019-rev-list-ancestry-path.sh
+++ b/t/t6019-rev-list-ancestry-path.sh
@@ -55,111 +55,42 @@ test_expect_success setup '
 	test_commit M
 '
 
-test_expect_success 'rev-list D..M' '
-	test_write_lines E F G H I J K L M >expect &&
-	git rev-list --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-
-test_expect_success 'rev-list --ancestry-path D..M' '
-	test_write_lines E F H I J L M >expect &&
-	git rev-list --ancestry-path --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-
-test_expect_success 'rev-list --ancestry-path=F D..M' '
-	test_write_lines E F J L M >expect &&
-	git rev-list --ancestry-path=F --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-test_expect_success 'rev-list --ancestry-path=G D..M' '
-	test_write_lines G H I J L M >expect &&
-	git rev-list --ancestry-path=G --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-test_expect_success 'rev-list --ancestry-path=H D..M' '
-	test_write_lines E G H I J L M >expect &&
-	git rev-list --ancestry-path=H --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-
-test_expect_success 'rev-list --ancestry-path=K D..M' '
-	test_write_lines K L M >expect &&
-	git rev-list --ancestry-path=K --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-
-test_expect_success 'rev-list --ancestry-path=F --ancestry-path=K D..M' '
-	test_write_lines E F J K L M >expect &&
-	git rev-list --ancestry-path=F --ancestry-path=K --format=%s D..M |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
-
-test_expect_success 'rev-list D..M -- M.t' '
-	echo M >expect &&
-	git rev-list --format=%s D..M -- M.t |
-	sed -e "/^commit /d" >actual &&
-	test_cmp expect actual
-'
-
-test_expect_success 'rev-list --ancestry-path D..M -- M.t' '
-	echo M >expect &&
-	git rev-list --ancestry-path --format=%s D..M -- M.t |
-	sed -e "/^commit /d" >actual &&
-	test_cmp expect actual
-'
+test_ancestry () {
+	args=$1
+	expected=$2
+	test_expect_success "rev-list $args" "
+		test_write_lines $expected >expect &&
+		git rev-list --format=%s $args >raw &&
+
+		if test -n \"$expected\"
+		then
+			sed -e \"/^commit /d\" raw | sort >actual &&
+			test_cmp expect actual || return 1
+		else
+			test_must_be_empty raw
+		fi
+	"
+}
 
-test_expect_success 'rev-list F...I' '
-	test_write_lines F G H I >expect &&
-	git rev-list --format=%s F...I |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
+test_ancestry "D..M" "E F G H I J K L M"
 
-test_expect_success 'rev-list --ancestry-path F...I' '
-	test_write_lines F H I >expect &&
-	git rev-list --ancestry-path --format=%s F...I |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
+test_ancestry "--ancestry-path D..M" "E F H I J L M"
+test_ancestry "--ancestry-path D..M" "E F H I J L M"
+test_ancestry "--ancestry-path=F D..M" "E F J L M"
+test_ancestry "--ancestry-path=G D..M" "G H I J L M"
+test_ancestry "--ancestry-path=H D..M" "E G H I J L M"
+test_ancestry "--ancestry-path=K D..M" "K L M"
+test_ancestry "--ancestry-path=K --ancestry-path=F D..M" "E F J K L M"
 
-# G.t is dropped in an "-s ours" merge
-test_expect_success 'rev-list G..M -- G.t' '
-	git rev-list --format=%s G..M -- G.t |
-	sed -e "/^commit /d" >actual &&
-	test_must_be_empty actual
-'
+test_ancestry "D..M -- M.t" "M"
+test_ancestry "--ancestry-path D..M -- M.t" "M"
 
-test_expect_success 'rev-list --ancestry-path G..M -- G.t' '
-	echo L >expect &&
-	git rev-list --ancestry-path --format=%s G..M -- G.t |
-	sed -e "/^commit /d" >actual &&
-	test_cmp expect actual
-'
+test_ancestry "F...I" "F G H I"
+test_ancestry "--ancestry-path F...I" "F H I"
 
-test_expect_success 'rev-list --ancestry-path --simplify-merges G^..M -- G.t' '
-	test_write_lines G L >expect &&
-	git rev-list --ancestry-path --simplify-merges --format=%s G^..M -- G.t |
-	sed -e "/^commit /d" |
-	sort >actual &&
-	test_cmp expect actual
-'
+test_ancestry "G..M -- G.t" ""
+test_ancestry "--ancestry-path G..M -- G.t" "L"
+test_ancestry "--ancestry-path --simplify-merges G^..M -- G.t" "G L"
 
 #   b---bc
 #  / \ /
-- 
2.37.1.vfs.0.0.rebase







[Index of Archives]     [Linux Kernel Development]     [Gcc Help]     [IETF Annouce]     [DCCP]     [Netdev]     [Networking]     [Security]     [V4L]     [Bugtraq]     [Yosemite]     [MIPS Linux]     [ARM Linux]     [Linux Security]     [Linux RAID]     [Linux SCSI]     [Fedora Users]

  Powered by Linux